import pygame
import math
from pygame.locals import *

pygame.init()
screen = pygame.display.set_mode((600, 500))
pygame.display.set_caption("Shooter")
background = pygame.image.load("bkg.png")
backgroundRect = background.get_rect()

player_img = pygame.image.load("player.png")
enemyI_img = pygame.image.load("enemyI.png")
enemyII_img = pygame.image.load("enemyII.png")
enemyIII_img = pygame.image.load("enemyIII.png")
enemyIV_img = pygame.image.load("enemyIV.png")
bomb_img = pygame.image.load("bomb.png")

# Player
class Player(pygame.sprite.Sprite):
    def __init__(self, initial_position):
        pygame.sprite.Sprite.__init__(self)
        self.image = player_img
        self.rect = self.image.get_rect()
        self.rect.center = initial_position
        self.dx = 0
        self.dy = 0

    def update(self):
        self.rect.right += self.dx
        if self.rect.left < 0 :
        	self.rect.left = 0
        elif self.rect.right > 600 :
        	self.rect.right = 600
# Gegner       	
class Enemy(pygame.sprite.Sprite):
	def __init__(self, initial_position):
		pygame.sprite.Sprite.__init__(self)
		self.image = enemyI_img
		self.rect = self.image.get_rect()
		self.rect.center = initial_position
		self.dx = 0
		self.dy = 0
		self.speed = 600
		self.counter = 4
		
	def update(self, time_passed):
		moved_distance = math.ceil(time_passed * self.speed)
		self.rect.centerx += moved_distance
		if self.rect.left < 0 :
			self.rect.bottom += 10
			self.rect.left = 0
			self.speed = -self.speed
		elif self.rect.right > 600 :
			self.rect.bottom += 20
			self.rect.right = 600
			self.speed = -self.speed
		elif self.rect.bottom > 500 :
			self.kill()
		if pygame.sprite.groupcollide(enemys, bombs, 0, 1):
			score.score += 1
			self.counter -= 1
			if self.counter == 0:
				self.kill()
			elif self.counter == 3:
				self.image = enemyII_img
			elif self.counter == 2:
				self.image = enemyIII_img
			elif self.counter == 1:
				self.image = enemyIV_img


# Bombe
class Bomb(pygame.sprite.Sprite):
	def __init__(self, position):
		pygame.sprite.Sprite.__init__(self)
		self.image = bomb_img
		self.rect = self.image.get_rect()
		self.rect.center = position
		
	def update(self):
		if self.rect.top < 0:
			self.kill()
		else:
			self.rect.move_ip(0,-10)
		if pygame.sprite.groupcollide(enemys, bombs, 0, 1):
			self.kill()
# Score
class Score(pygame.sprite.Sprite):
    def __init__(self):
        pygame.sprite.Sprite.__init__(self)
        self.score = 0
        self.font = pygame.font.Font("arial.ttf", 20)
        
    def update(self):
        self.text = "Score: %d" % self.score
        self.image = self.font.render(self.text, 1, (0, 0, 0))
        self.rect = self.image.get_rect()
        self.rect.center = (540,20)

# Game Over
class Gameover(pygame.sprite.Sprite):
    def __init__(self):
        pygame.sprite.Sprite.__init__(self)
        self.font = pygame.font.Font("arial.ttf", 48)
        
    def update(self):
        self.text = ("Game Over")
        self.image = self.font.render(self.text, 1, (0, 0, 0))
        self.rect = self.image.get_rect()
        self.rect.center = (300,250)

# Player
player = Player((250,470))

# Enemys
global enemys
enemys = pygame.sprite.RenderPlain(())
enemys.add(Enemy((20,25)))
enemys.add(Enemy((100,25)))
enemys.add(Enemy((180,25)))
enemys.add(Enemy((260,25)))
enemys.add(Enemy((340,25)))

# Bombs
global bombs
bombs = pygame.sprite.RenderPlain(())

# Score and Game Over
global score
score = Score()
scoreSprite = pygame.sprite.Group(score)
gameOverSprite = pygame.sprite.RenderPlain(())

clock = pygame.time.Clock()
playerSprite = pygame.sprite.RenderPlain((player))

while True:
	for event in pygame.event.get():
		if event.type == QUIT:
			exit()
        if event.type == pygame.KEYDOWN:
        	if event.key == pygame.K_RIGHT:
        		player.dx = 5
        	if event.key == pygame.K_LEFT:
        		player.dx = -5
        	if event.key == pygame.K_SPACE:
        		bombs.add(Bomb(player.rect.center))
        elif event.type == KEYUP:
        	player.dx = 0
	screen.blit(background, backgroundRect)
	time_passed = clock.tick() / 1000.0
	
	# Draw and Update
	playerSprite.update()
	playerSprite.draw(screen)
	enemys.update(time_passed)
	enemys.draw(screen)
	bombs.update()
	bombs.draw(screen)
	scoreSprite.update()
	scoreSprite.draw(screen)
	gameOverSprite.update()
	gameOverSprite.draw(screen)
	
	pygame.display.flip()
	
	# Game Over
	for hit in pygame.sprite.groupcollide(enemys, playerSprite, 1, 0):
		gameOverSprite.add(Gameover())
		playerSprite.remove(player)            